Imports System.Runtime.InteropServices
Public Interface _Complex
    Structure ComplexVariable
        Dim Re As Double
        Dim Im As Double
    End Structure
    Function Cmplx(ByVal Real As Double, Optional ByVal Imag As Double = 0) As ComplexVariable
    Function Polar(ByVal Rho As Double, ByVal Arg As Double) As ComplexVariable
    Function Real(ByVal X As ComplexVariable) As Double
    Function Imag(ByVal X As ComplexVariable) As Double
    Function Rho(ByVal X As ComplexVariable) As Double
    Function Arg(ByVal X As ComplexVariable) As Double
    Function ComplexToString(ByRef X As ComplexVariable, Optional ByVal N As Integer = 2, Optional ByVal Exponentional As Boolean = False) As String
    Function ComplexToPolarString(ByRef X As ComplexVariable, Optional ByVal N As Integer = 2) As String
    Function Cconj(ByRef X As ComplexVariable) As ComplexVariable
    Function Cadd(ByRef X As ComplexVariable, ByRef Y As ComplexVariable) As ComplexVariable
    Function Csubtract(ByRef X As ComplexVariable, ByRef Y As ComplexVariable) As ComplexVariable
    Function Cmultiply(ByRef X As ComplexVariable, ByRef Y As ComplexVariable) As ComplexVariable
    Function Cdivide(ByRef X As ComplexVariable, ByRef Y As ComplexVariable) As ComplexVariable
    Function Cpower(ByRef X As ComplexVariable, ByVal Power As Object) As ComplexVariable
    Function Csqr(ByRef X As ComplexVariable) As ComplexVariable
    Function CsqrN(ByRef X As ComplexVariable, ByVal N As Integer) As Object
    Function Cnegative(ByRef X As ComplexVariable) As ComplexVariable
    Function Cinvert(ByRef X As ComplexVariable) As ComplexVariable
    Function Cexp(ByRef X As ComplexVariable) As ComplexVariable
    Function Clog(ByRef X As ComplexVariable) As ComplexVariable
    Function Clog10(ByRef X As ComplexVariable) As ComplexVariable
    Function Csin(ByRef X As ComplexVariable) As ComplexVariable
    Function Ccos(ByRef X As ComplexVariable) As ComplexVariable
    Function Ctan(ByRef X As ComplexVariable) As ComplexVariable
    Function Csinh(ByRef X As ComplexVariable) As ComplexVariable
    Function Ccosh(ByRef X As ComplexVariable) As ComplexVariable
    Function Ctanh(ByRef X As ComplexVariable) As ComplexVariable
    Function Cequals(ByRef X As ComplexVariable, ByRef Y As ComplexVariable) As Boolean
End Interface
<ComClass(Complex.ClassId, Complex.InterfaceId, Complex.EventsId)> Public Class Complex
    Implements _Complex
#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "C7A24C46-32B3-43d5-9D51-3A8C075D01A0"
    Public Const InterfaceId As String = "F28AD3A5-DD5B-44d8-A7F8-7671FC0C1E1D"
    Public Const EventsId As String = "E683E5E6-E29D-48bc-A946-A43BA1FB5B4E"
#End Region
#Region "Public"
    '       .  
    '       
    '    .
    ' :
    ' -------------
    ' zOut = Cmplx(Re, Im)          : zOut = Re+i*Im
    ' zOut = Polar(Rho, Arg)        : zOut = Rho*Exp(i*Arg)
    '                                      = Rho*[Cos(Arg) + i*Sin(Arg)]
    '
    ' Function Re(z) As Double      : zOut = Re
    ' Function Im(z) As Double      : zOut = Im
    ' Function Rho(z) As Double     : zOut = sqr(Re^2+Im^2))
    ' Function Arg(z) As Double     : zOut = atn(Im/Re)
    '
    ' Function ComplexToString(z) As String     : zOut = "Re+i*Im"
    ' Function PolarToString(z) As String       : zOut = "Rho*Exp(i*Arg)"
    '
    ' zOut = Conj(X)                : zOut = Re-i*Im  (if X=Re+iIm)
    ' zOut = Cadd(X, Y)             : zOut = X+Y
    ' zOut = Csubtract(X, Y)        : zOut = X-Y
    ' zOut = Cmultiply(X, Y)        : zOut = X*Y
    ' zOut = Cdivide(X, Y)          : zOut = X/Y
    ' zOut = Cpower(X, power)       : zOut = X^power
    ' zOut = Cpower(X, Y)           : zOut = X^Y
    ' zOut = Csqr(X)                : zOut = Sqr(X)
    ' zOut = CsqrN(X,N)             : zOut = Sqr(X,N)
    ' zOut = Cnegative(X)           : zOut = -X
    ' zOut = Cinvert(X)             : zOut = 1/X
    ' zOut = Cexp(X)                : zOut = exp(X)
    ' zOut = Clog(X)                : zOut = log(X)
    ' zOut = Clog10(X)              : zOut = log10(X)
    '
    ' zOut = Csin(X)                : zOut = sin(X)
    ' zOut = Ccos(X)                : zOut = cos(X)
    ' zOut = Ctan(X)                : zOut = tan(X)
    ' zOut = Csh(X)                 : zOut = sh(X)
    ' zOut = Cch(X)                 : zOut = ch(X)
    ' zOut = Cth(X)                 : zOut = th(X)
    '
    ' zOut = Cequals(X,Y)           : zOut = False  (if X<>Y)
    '                               : zOut = True   (if X=Y)
    '============================================================================

    <ComRegisterFunction()> Public Shared Sub OnRegistration(ByVal T As Type)
        MsgBox("I'm being registered!!! :" & T.FullName)
    End Sub

    '============================================================================
    '   
    '============================================================================
    '      Real   Imag 
    <ComRegisterFunction()> Public Function Cmplx(ByVal Real As Double, Optional ByVal Imag As Double = 0) As _Complex.ComplexVariable Implements _Complex.Cmplx
        Cmplx.Re = Real
        Cmplx.Im = Imag
    End Function

    '       Rho   Arg:
    ' Polar = Rho*Exp(i*Arg) = Rho*[Cos(Arg)+i*Sin(Arg)]
    <ComRegisterFunction()> Public Function Polar(ByVal Rho As Double, ByVal Arg As Double) As _Complex.ComplexVariable Implements _Complex.Polar
        Polar.Re = Rho * System.Math.Cos(Arg)
        Polar.Im = Rho * System.Math.Sin(Arg)
    End Function

    '============================================================================
    ' ,  
    '============================================================================
    '   Real   
    <ComRegisterFunction()> Public Function Real(ByVal X As _Complex.ComplexVariable) As Double Implements _Complex.Real
        Real = X.Re
    End Function

    '   Imag   
    <ComRegisterFunction()> Public Function Imag(ByVal X As _Complex.ComplexVariable) As Double Implements _Complex.Imag
        Imag = X.Im
    End Function

    '   Rho  : sqr(Re^2+Im^2)
    <ComRegisterFunction()> Public Function Rho(ByVal X As _Complex.ComplexVariable) As Double Implements _Complex.Rho
        '  Rho=sqr(Re^2+Im^2)   ,
        '  Re  Im       ,
        '    
        If X.Im = 0 Then
            Rho = System.Math.Abs(X.Re)
        ElseIf System.Math.Abs(X.Re) < System.Math.Abs(X.Im) Then
            Rho = System.Math.Abs(X.Im) * System.Math.Sqrt(1 + Square(X.Re / X.Im))
        Else
            Rho = System.Math.Abs(X.Re) * System.Math.Sqrt(1 + Square(X.Im / X.Re))
        End If
    End Function

    '   Arg  : tan(arg)=tan(Im/Re)
    <ComRegisterFunction()> Public Function Arg(ByVal X As _Complex.ComplexVariable) As Double Implements _Complex.Arg
        Arg = System.Math.Atan2(X.Im, X.Re)
    End Function

    '     : "Re+i*Im"
    <ComRegisterFunction()> Public Function ComplexToString(ByRef X As _Complex.ComplexVariable, _
                                                            Optional ByVal N As Integer = 2, _
                                                            Optional ByVal Exponentional As Boolean = False) As String Implements _Complex.ComplexToString
        Dim F, XRE, XIM As String
        Dim I As Integer

        If Exponentional Then
            Select Case N
                Case Is > 0
                    F = "0."
                    For I = 1 To N
                        F = F & "0"
                    Next I
                Case 0
                    F = "0"
                Case Else
                    Err.Raise(vbObjectError + 101, "Complex.dll", "   ")
            End Select
            F = F & "e+00"
            '    
            If X.Re = Fix(X.Re) And X.Re <> 0 And System.Math.Abs(X.Re) < 10 Then
                XRE = X.Re
            Else
                XRE = Format(X.Re, F)
                Do
                    I = InStr(XRE, "0e") Or InStr(XRE, ",e")
                    If I = 0 Then Exit Do
                    If InStr(XRE, ",") Then
                        XRE = Mid(XRE, 1, I - 1) & Right(XRE, 4)
                    End If
                    If XRE = "0e+00" Then XRE = ""
                Loop
            End If
            '    
            If X.Im = Fix(X.Im) And X.Im <> 0 And System.Math.Abs(X.Im) < 10 Then
                If X.Im = 1 Then
                    If XRE = "" Then
                        XIM = "i"
                    Else
                        XIM = "+i"
                    End If
                ElseIf X.Im = -1 Then
                    XIM = "-i"
                ElseIf X.Im > 0 Then
                    If XRE = "" Then
                        XIM = X.Im & "i"
                    Else
                        XIM = "+" & X.Im & "i"
                    End If
                Else
                    XIM = X.Im & "i"
                End If
            Else
                If X.Im > 0 Then
                    XIM = Format(X.Im, F)
                    If XIM <> 0 Then
                        XIM = "+" & XIM
                        Do
                            I = InStr(XIM, "0e") Or InStr(XIM, ",e")
                            If I = 0 Then Exit Do
                            If InStr(XIM, ",") Then
                                XIM = Mid$(XIM, 1, I - 1) & Right$(XIM, 4)
                            End If
                        Loop
                    End If
                    XIM = XIM & "i"
                ElseIf X.Im < 0 Then
                    XIM = Format(X.Im, F)
                    If XIM <> 0 Then
                        Do
                            I = InStr(XIM, "0e") Or InStr(XIM, ",e")
                            If I = 0 Then Exit Do
                            If InStr(XIM, ",") > 0 Then
                                XIM = Mid$(XIM, 1, I - 1) & Right$(XIM, 4)
                            End If
                        Loop
                    End If
                    XIM = XIM & "i"
                End If
            End If
        Else
            '    
            XRE = FormatNumber(X.Re, N, GroupDigits:=TriState.False)
            Do While (Right$(XRE, 1) = "0" Or Right$(XRE, 1) = ",") And InStr(XRE, ",")
                XRE = Left$(XRE, Len(XRE) - 1)
            Loop
            '    
            If X.Im > 0 Then
                If FormatNumber(X.Im, N, GroupDigits:=TriState.False) <> 0 Then
                    XIM = "+" & FormatNumber(X.Im, N, GroupDigits:=TriState.False)
                    Do While (Right$(XIM, 1) = "0" Or Right$(XIM, 1) = ",") And InStr(XIM, ",")
                        XIM = Left$(XIM, Len(XIM) - 1)
                    Loop
                    If XIM = "+1" Then
                        XIM = "+i"
                    Else
                        XIM = XIM & "i"
                    End If
                End If
            ElseIf X.Im < 0 Then
                If FormatNumber(X.Im, N, GroupDigits:=TriState.False) <> 0 Then
                    XIM = "-" & FormatNumber(System.Math.Abs(X.Im), N, GroupDigits:=TriState.False)
                    Do While (Right$(XIM, 1) = "0" Or Right$(XIM, 1) = ",") And InStr(XIM, ",")
                        XIM = Left$(XIM, Len(XIM) - 1)
                    Loop
                    If XIM = "-1" Then
                        XIM = "-i"
                    Else
                        XIM = XIM & "i"
                    End If
                End If
            End If
        End If
        ComplexToString = XRE & XIM
        If ComplexToString = "" Then ComplexToString = "0"
    End Function

    '     : "Rho*Exp(i*Arg)"
    <ComRegisterFunction()> Public Function ComplexToPolarString(ByRef X As _Complex.ComplexVariable, Optional ByVal N As Integer = 2) As String Implements _Complex.ComplexToPolarString
        Dim R, A As Double

        R = Rho(X)
        A = Arg(X)
        ComplexToPolarString = FormatNumber(R, N) & "*Exp(" & FormatNumber(A, N) & "i)"
    End Function

    '============================================================================
    '    
    '============================================================================
    '      : zOut=Re-i*Im  (if X=Re+i*Im)
    <ComRegisterFunction()> Public Function Cconj(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cconj
        Cconj.Re = X.Re
        Cconj.Im = -X.Im
    End Function

    '    : zOut=X+Y
    <ComRegisterFunction()> Public Function Cadd(ByRef X As _Complex.ComplexVariable, ByRef Y As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cadd
        Cadd.Re = X.Re + Y.Re
        Cadd.Im = X.Im + Y.Im
    End Function

    '    : zOut=X-Y
    <ComRegisterFunction()> Public Function Csubtract(ByRef X As _Complex.ComplexVariable, ByRef Y As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Csubtract
        Csubtract.Re = X.Re - Y.Re
        Csubtract.Im = X.Im - Y.Im
    End Function

    '    : zOut=X*Y
    <ComRegisterFunction()> Public Function Cmultiply(ByRef X As _Complex.ComplexVariable, ByRef Y As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cmultiply
        Cmultiply.Re = X.Re * Y.Re - X.Im * Y.Im
        Cmultiply.Im = X.Re * Y.Im + X.Im * Y.Re
    End Function

    '    : zOut=X/Y
    <ComRegisterFunction()> Public Function Cdivide(ByRef X As _Complex.ComplexVariable, ByRef Y As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cdivide
        Dim E, F, P, Q As Double

        If System.Math.Abs(Y.Im) < System.Math.Abs(Y.Re) Then
            E = Y.Im / Y.Re
            F = Y.Re + Y.Im * E
            P = (X.Re + X.Im * E) / F
            Q = (X.Im - X.Re * E) / F
        Else
            E = Y.Re / Y.Im
            F = Y.Im + Y.Re * E
            P = (X.Im + X.Re * E) / F
            Q = (-X.Re + X.Im * E) / F
        End If
        Cdivide.Re = P
        Cdivide.Im = Q
    End Function

    '     : zOut=X^power,
    '       zOut=X^Y
    <ComRegisterFunction()> Public Function Cpower(ByRef X As _Complex.ComplexVariable, ByVal Power As Object) As _Complex.ComplexVariable Implements _Complex.Cpower
        Dim Y As _Complex.ComplexVariable
        Dim R, A, V, P, W As Double

        Select Case TypeName(Power)
            Case "Integer", "Long", "Single", "Double"
                R = Rho(X) ^ Power
                A = Arg(X) * Power
                Cpower = Polar(R, A)
            Case "_Complex.ComplexVariable"
                Y = Power
                If X.Re <> 0 And X.Im <> 0 Then
                    P = Arg(X)
                    R = System.Math.Log(Rho(X))
                    V = Y.Re * P + Y.Im * R
                    W = System.Math.Exp(Y.Re * R - Y.Im * P)
                    Cpower = Cmplx(W * System.Math.Cos(V), W * System.Math.Sin(V))
                Else
                    Cpower = Cmplx(0, 0)
                End If
        End Select
    End Function

    '      : zOut=sqr(X)
    <ComRegisterFunction()> Public Function Csqr(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Csqr
        Dim R, A As Double

        R = Rho(X) ^ 0.5
        A = Arg(X) * 0.5
        Csqr = Polar(R, A)
    End Function

    '   N-    : zOut=sqr(X,N)
    <ComRegisterFunction()> Public Function CsqrN(ByRef X As _Complex.ComplexVariable, ByVal N As Integer) As Object Implements _Complex.CsqrN
        Dim TETAN, ODN, TPN, R2, R, R1, TETA As Double
        Dim K As Integer
        Dim Y(N) As _Complex.ComplexVariable

        ODN = 1 / N
        R = Rho(X) ^ ODN
        Select Case X.Re
            Case Is > 0 : TETA = Arg(X)
            Case Is < 0 : TETA = Arg(X) + System.Math.PI
            Case Else : TETA = ExtSign(System.Math.PI / 2, X.Im)
        End Select
        TETAN = TETA * ODN
        TPN = 2 * System.Math.PI * ODN
        R1 = System.Math.Cos(TPN)
        R2 = System.Math.Sin(TPN)
        Y(1) = Cmplx(System.Math.Cos(TETAN), System.Math.Sin(TETAN))
        For K = 2 To N
            Y(K) = Cmplx(Y(K - 1).Re * R1 - Y(K - 1).Im * R2, _
                         Y(K - 1).Im * R1 + Y(K - 1).Re * R2)
        Next K
        For K = 1 To N
            Y(K) = Cmultiply(Y(K), Cmplx(R, 0))
        Next K
        CsqrN = Y
    End Function

    '    : zOut=-X
    <ComRegisterFunction()> Public Function Cnegative(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cnegative
        Cnegative.Re = -X.Re
        Cnegative.Im = -X.Im
    End Function

    '   : zOut=1/X
    <ComRegisterFunction()> Public Function Cinvert(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cinvert
        Cinvert = Cdivide(Cmplx(1, 0), X)
    End Function

    '    : zOut=exp(X)
    ' Re(X)=exp(Re(X))*cos(Im(X))
    ' Im(X)=exp(Re(X))*sin(Im(X))
    <ComRegisterFunction()> Public Function Cexp(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Cexp
        Dim ExHibitors As Double

        Call MCON(EXHIB:=ExHibitors)
        If System.Math.Abs(X.Re) > ExHibitors Then
            Err.Raise(vbObjectError + 102, "Complex.dll", " ")
        Else
            Cexp.Re = System.Math.Exp(X.Re) * System.Math.Cos(X.Im)
            Cexp.Im = System.Math.Exp(X.Re) * System.Math.Sin(X.Im)
        End If
    End Function

    '     : zOut=log(X)
    ' Re(X)=0.5*log(Re(X)^2+Im(X)^2)
    ' Im(X)=atn(Im(X)/Re(X))
    <ComRegisterFunction()> Public Function Clog(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Clog
        Clog.Re = System.Math.Log(Rho(X))
        Clog.Im = Arg(X)
    End Function

    '     : zOut=log10(X)
    <ComRegisterFunction()> Public Function Clog10(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Clog10
        Dim A As _Complex.ComplexVariable

        A = Clog(X)
        Clog10.Re = A.Re / System.Math.Log(10)
        Clog10.Im = A.Im / System.Math.Log(10)
    End Function

    '    : zOut=sin(X)
    ' Re(X)=sin(Re(X))*cosh(Im(X))
    ' Im(X)=cos(Re(X))*sinh(Im(X))
    <ComRegisterFunction()> Public Function Csin(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Csin
        Csin.Re = System.Math.Sin(X.Re) * System.Math.Cosh(X.Im)
        Csin.Im = System.Math.Cos(X.Re) * System.Math.Sinh(X.Im)
    End Function

    '    : zOut=cos(X)
    ' Re(X)=cos(Re(X))*cosh(Im(X))
    ' Im(X)=-sin(Re(X))*sinh(Im(X))
    <ComRegisterFunction()> Public Function Ccos(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Ccos
        Ccos.Re = System.Math.Cos(X.Re) * System.Math.Cosh(X.Im)
        Ccos.Im = -System.Math.Sin(X.Re) * System.Math.Sinh(X.Im)
    End Function

    '    : zOut=tan(X)
    ' Re(X)=sin(2*Re(X))/(cos(2*Re(X))+cosh(2*Im(X)))
    ' Im(X)=sinh(2*Im(X))/(cos(2*Re(X))+cosh(2*Im(X)))
    <ComRegisterFunction()> Public Function Ctan(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Ctan
        Ctan.Re = System.Math.Sin(2 * X.Re) / (System.Math.Cos(2 * X.Re) + System.Math.Cosh(2 * X.Im))
        Ctan.Im = System.Math.Sinh(2 * X.Im) / (System.Math.Cos(2 * X.Re) + System.Math.Cosh(2 * X.Im))
    End Function

    '     : zOut=sinh(X)
    ' Re(X)=sinh(Re(X))*cos(Im(X))
    ' Im(X)=cosh(Re(X))*sin(Im(X))
    <ComRegisterFunction()> Public Function Csinh(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Csinh
        Csinh.Re = System.Math.Sinh(X.Re) * System.Math.Cos(X.Im)
        Csinh.Im = System.Math.Cosh(X.Re) * System.Math.Sin(X.Im)
    End Function

    '     : zOut=cosh(X)
    ' Re(X)=cosh(Re(X))*cos(Im(X))
    ' Im(X)=sinh(Re(X))*sin(Im(X))
    <ComRegisterFunction()> Public Function Ccosh(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Ccosh
        Ccosh.Re = System.Math.Cosh(X.Re) * System.Math.Cos(X.Im)
        Ccosh.Im = System.Math.Sinh(X.Re) * System.Math.Sin(X.Im)
    End Function

    '     : zOut=th(X)
    <ComRegisterFunction()> Public Function Ctanh(ByRef X As _Complex.ComplexVariable) As _Complex.ComplexVariable Implements _Complex.Ctanh
        Ctanh = Cdivide(Csinh(X), Ccosh(X))
    End Function

    '      : zOut=(X=Y)
    <ComRegisterFunction()> Public Function Cequals(ByRef X As _Complex.ComplexVariable, ByRef Y As _Complex.ComplexVariable) As Boolean Implements _Complex.Cequals
        Dim ETA As Double

        Call MCON(ETA)
        If System.Math.Abs(X.Re - Y.Re) <= System.Math.Sqrt(ETA) And System.Math.Abs(X.Im - Y.Im) <= System.Math.Sqrt(ETA) Then
            Cequals = True
        End If
    End Function
#End Region

#Region "Private"
    '============================================================================
    '  
    '============================================================================
    '  X^2
    Private Function Square(ByVal X As Double) As Double
        Square = X * X
    End Function

    '   A   B
    '  B>=0 A=abs(A)
    '  B<0  A=-abs(A)
    Private Function ExtSign(ByVal A As Double, ByVal B As Double) As Double
        If B >= 0 Then
            ExtSign = System.Math.Abs(A)
        Else
            ExtSign = -System.Math.Abs(A)
        End If
    End Function

    ' MCON    ,   -
    '    .    -
    '   ,      ,  -
    ' .
    Private Sub MCON(Optional ByRef ETA As Double = 0, _
                     Optional ByRef EXHIB As Double = 0)
        ' ETA -    , -
        '             
        '         ,   1+ETA ,  1
        ' INFINY -     
        ' SMALNO -      
        ' BASE -       -
        '           
        ' EXHIB -   
        '
        '   -         (
        ' ).  A -   5***(1-),  B**(1-T)  -
        '   ,     .
        '
        '  M - ,  N -    
        '    .
        '  INFINY -  (1 - BASE**(-T))*BASE**M, a
        '       SMALNO - o BASE**N.
        Dim INFINY, SMALNO As Double
        Dim BASE, N, M, T As Integer

        BASE = 16
        T = 14
        M = 255
        N = -268
        ETA = BASE ^ (1 - T)
        INFINY = BASE * (1 - BASE ^ (-T)) * BASE ^ (M - 1)
        SMALNO = (BASE ^ (N + 3)) / BASE ^ 3
        EXHIB = System.Math.Log(INFINY)
    End Sub
#End Region
End Class